#include <GDIplus.au3>
#include <WindowsConstants.au3>
_GDIPlus_Startup()


Global $trans = 255,$width_old,$width_new,$gro=0
HotKeySet( "{ESC}" ,"_Exit")
;Systeminformationen sammeln:
$x = 0
$y = 0
$w = @DesktopWidth
$h = @DesktopHeight



#Region Data
$path = @ScriptDir & "\Wald\Background\"
;Wald = 18
;Wste = 5
;Bebsch = 25
;Wiese = 18
;Duegon = 18
$y_back = 18

;Wald = 28
;Wste = 17
;Bebsch = 20
;Wiese = 20
;Duegon = 20
$y_front = 28

;Wald = 90
;Wste = 0
;Bebsch = 20
;Wiese = 0
;Duegon = 50
$y_background = 90

;Wald = 100
;Wste = 50
;Bebsch = 0
;Wiese = 0
;Duegon = 50
$x_front = 100	;Abstand zwischen den FrontObjekts

;Wald = -50
;Wste = 50
;Bebsch = 0
;Wiese = -20
;Duegon = -50
$x_back = -50	;Abstand zwischen den BackObjekts



$move_0 = _GDIPlus_BitmapCreateFromFile($path & "move_0.png")

;Background
dim $background[1]
$background[0] = _GDIPlus_BitmapCreateFromFile($path & "background_0.png")

;Boden
dim $boden[1]
while FileExists($path & "boden_"&$gro &".png")
	redim $boden[$gro+1]
	$boden[$gro] = _GDIPlus_BitmapCreateFromFile($path & "boden_"&$gro&".png")
	$gro = $gro + 1
wend

;Erde
$gro = 0
dim  $erde[1]
while FileExists($path & "erde_"&$gro &".png")
	redim  $erde[$gro+1]
	 $erde[$gro] = _GDIPlus_BitmapCreateFromFile($path & "erde_"&$gro&".png")
	$gro = $gro + 1
wend

;Back-Objekts
$gro = 0
dim  $back[1]
while FileExists($path & "back_"&$gro &".png")
	redim  $back[$gro+1]
	$back[$gro] = _GDIPlus_BitmapCreateFromFile($path & "back_"&$gro&".png")
	$gro = $gro + 1
wend

;Front-Objekts
$gro = 0
dim  $front[1]
while FileExists($path & "front_"&$gro &".png")
	redim  $front[$gro+1]
	$front[$gro] = _GDIPlus_BitmapCreateFromFile($path & "front_"&$gro&".png")
	$gro = $gro + 1
wend
#EndRegion Data
;EndRegion Data


#Region Background
;Create Background
Global $hwnd = GUICreate("Maple-Screen", $w, $h, $x, $y, 0, BitOR($WS_EX_LAYERED, $WS_EX_TOPMOST))
WinSetOnTop($hwnd, "", 1)

$ScreenDc = _WinAPI_GetDC($hWnd)
$dc = _WinAPI_CreateCompatibleDC($ScreenDc)
; _WinAPI_UpdateLayeredWindow parameters
$tSize = DllStructCreate($tagSIZE)
$pSize = DllStructGetPtr($tSize)
DllStructSetData($tSize, "X", $w)
DllStructSetData($tSize, "Y", $h)
$tSource = DllStructCreate($tagPOINT)
$pSource = DllStructGetPtr($tSource)
$tBlend = DllStructCreate($tagBLENDFUNCTION)
$pBlend = DllStructGetPtr($tBlend)
DllStructSetData($tBlend, "Alpha", $trans)
DllStructSetData($tBlend, "Format", 1)
$tPoint = DllStructCreate($tagPOINT)
$pPoint = DllStructGetPtr($tPoint)
DllStructSetData($tPoint, "X", 0)
DllStructSetData($tPoint, "Y", 0)

$graphics = _GDIPlus_GraphicsCreateFromHWND($hwnd)
$bitmap = _GDIPlus_BitmapCreateFromGraphics($w, $h, $graphics)
$backbuffer = _GDIPlus_ImageGetGraphicsContext($bitmap)

GUISetState()
WinSetOnTop($hwnd, "", 1)
#EndRegion Background
;EndRegion Background


#Region Create Background
;Background erstellen:
AddBitmap($background[0], -(_GDIPlus_ImageGetWidth($background[0])/2-$w/2)+Random(-100,100,1),$y+$h-_GDIPlus_ImageGetHeight($background[0])-60-$y_background )

;Back-Objekts erstellen
while $width_old < $w
	$pic_lns = $back[Random(0,ubound($back)-1,1)]
	$height_lns = _GDIPlus_ImageGetHeight($pic_lns)
	$width_new = _GDIPlus_ImageGetWidth($pic_lns)
	AddBitmap($pic_lns,$width_old -$x_back,$y+$h-60-$y_back -$height_lns)
	$width_old = $width_new + $width_old+Random(-40,0,1)+$x_back
WEnd

;Erde erstellen
for $i = 0 to $w/90 step 1
	AddBitmap($erde[Random(0,ubound($erde)-1,1)],$i*90,$y+$h-60)
Next

;Boden erstellen
for $i = 0 to $w/90 step 1
	$pic_lns = $boden[Random(0,ubound($boden)-1,1)]
	AddBitmap($pic_lns,$i*90,$y+$h-60-_GDIPlus_ImageGetHeight($pic_lns))
Next

;Front-Objekts erstellen
$width_old = 0
while $width_old < $w
	$pic_lns = $front[Random(0,ubound($front)-1,1)]
	$height_lns = _GDIPlus_ImageGetHeight($pic_lns)
	$width_new = _GDIPlus_ImageGetWidth($pic_lns)
	AddBitmap($pic_lns,$width_old-$x_front ,$y+$h-60-$y_front-$height_lns)
	$width_old = $width_new + $width_old+Random(50,100,1)+$x_front
WEnd

SetBitmap()

 $Clone = _GDIPlus_BitmapCloneArea($bitmap, 0, 0, _GDIPlus_ImageGetWidth($bitmap),_GDIPlus_ImageGetHeight($bitmap), $GDIP_PXF64PARGB )
#EndRegion Create Background
;EndRegion Create Background



for $i = 0 to $w step 1
	$bitmap = _GDIPlus_BitmapCreateFromGraphics($w, $h, $graphics)
	$backbuffer = _GDIPlus_ImageGetGraphicsContext($bitmap)
	
	
	AddBitmap($Clone,0,0)
	AddBitmap($move_0,$i,200)
	AddBitmap($move_0,$i+200,100)
	SetBitmap()
	
	Sleep(100)
	
	 _GDIPlus_GraphicsDispose($backbuffer)
    _GDIPlus_BitmapDispose($bitmap)



next
	
	

	Sleep(3000)



#Region Funktionen

func AddBitmap($bit_grl,$x_grl,$y_grl)	;Bitmap,x,y,Transparens
;Complete
	_GDIPlus_GraphicsDrawImage($backbuffer, $bit_grl, $x_grl, $y_grl) ;draw background
EndFunc


func SetBitmap()
;Draw Bitmap
	$gdibitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($bitmap)
	_WinAPI_SelectObject($dc, $gdibitmap)
	_WinAPI_UpdateLayeredWindow($hWnd, $ScreenDc, 0, $pSize, $dc, $pSource, 0, $pBlend, 2)
EndFunc


Func _Exit()
    _WinAPI_DeleteDC($dc)
    _WinAPI_ReleaseDC($hWnd, $ScreenDc)
    _GDIPlus_GraphicsDispose($backbuffer)
    _GDIPlus_BitmapDispose($bitmap)
    _GDIPlus_GraphicsDispose($graphics)
    _GDIPlus_Shutdown()
    WinClose($hwnd)
    Exit
EndFunc